Index: trunk/source/processes/hadronic/models/chiral_inv_phase_space/body/src/G4QEnvironment.cc
===================================================================
--- trunk/source/processes/hadronic/models/chiral_inv_phase_space/body/src/G4QEnvironment.cc	(revision 1007)
+++ trunk/source/processes/hadronic/models/chiral_inv_phase_space/body/src/G4QEnvironment.cc	(revision 1055)
@@ -3706,9 +3859,9 @@
                       G4cout<<"***G4QE::HQE:FillAsIs(8),QC="<<totQC<<",4M="<<tot4M<<G4endl;
 #endif
-				                  //throw G4QException("G4QEnv::HadrQE:2K+ResidNucleus DecIn3 Error");
+                      //throw G4QException("G4QEnv::HadrQE:2K+ResidNucleus DecIn3 Error");
                     }
                     delete quasH;  
                     return theQHadrons;
-			               }
+                  }
                   G4QHadron* H1 = new G4QHadron(PDG1,k14M);
                   theQHadrons.push_back(H1);     // (delete equivalent)
@@ -3727,26 +3880,26 @@
 #endif
                   break;
-			             }
+                }
                 else totM=270000.;               // => "Continue reversion" case
-			           }
+              }
               else totM=300000.;                 // => "Continue reversion" case
-			         }
+            }
             else
-			         {
+            {
               if     (totPDG==1114||totPDG==2224||totPDG==10) // Decay right now and finish
-			           {
+              {
                 G4double m1=mNeut;
                 G4int  PDG1=2112;
                 G4double m2=mPi;
                 G4int  PDG2=-211;
-				            if(totPDG==2224)
-				            {
+                if(totPDG==2224)
+                {
                   m1=mProt;
                   PDG1=2212;
                   m2=mPi;
                   PDG2=211;
-				            }
+                }
                 else if(totPDG==10)              // "Chipolino" case
-				            {
+                {
                   G4QChipolino resChip(totQC);   // define the residual as a Chipolino
                   G4QPDGCode h1=resChip.GetQPDG1();
@@ -3756,16 +3909,16 @@
                   PDG2=h2.GetPDGCode();          // PDG code of the second hadron
                   m2  =h2.GetMass();             // Mass of the second hadron
-				            }
+                }
                 if(totMass>m1+m2)
-				            {
+                {
                   G4LorentzVector fq4M(0.,0.,0.,m1);
                   G4LorentzVector qe4M(0.,0.,0.,m2);
                   if(!G4QHadron(tot4M).DecayIn2(fq4M,qe4M))
-			               {
+                  {
                     G4cout<<"---Warning---G4QE::HaQE:tM="<<tot4M.m()<<"-> h1="<<PDG1<<"(M="
-					                     <<m1<<") + h2="<<PDG2<<"(M="<<m2<<")="<<m1+m2<<G4endl;
+                          <<m1<<") + h2="<<PDG2<<"(M="<<m2<<")="<<m1+m2<<G4endl;
                     G4Quasmon* quasH = new G4Quasmon(totQC,tot4M); // totQC not tQC!
                     CleanUp();
-		                  if(!CheckGroundState(quasH,true))
+                    if(!CheckGroundState(quasH,true))
                     {
                       G4QHadron* hadr = new G4QHadron(totQC,tot4M); // totQC not tQC!
@@ -3774,9 +3927,9 @@
                       G4cout<<"***G4QE::HQE:FillAsIs(9),QC="<<totQC<<",4M="<<tot4M<<G4endl;
 #endif
-				                  //throw G4QException("G4QEnv::HadrQEnv: h1+h2 DecayIn2 Error");
+                      //throw G4QException("G4QEnv::HadrQEnv: h1+h2 DecayIn2 Error");
                     }
                     delete quasH;  
                     return theQHadrons;
-			               }
+                  }
                   G4QHadron* H1 = new G4QHadron(PDG1,fq4M);
                   theQHadrons.push_back(H1);     // (delete equivalent)
@@ -3790,45 +3943,45 @@
                   theQHadrons.push_back(H2);     // (delete equivalent)
                   break;
-				            }
+                }
                 else totM=350000.;
-			           }
-			           else if(totPDG) totM=G4QPDGCode(totPDG).GetMass();
+              }
+              else if(totPDG) totM=G4QPDGCode(totPDG).GetMass();
               else totM=400000.;
-			         }
+            }
             totBN=totQC.GetBaryonNumber();      // The BaryNum after addition
             totS=totQC.GetStrangeness();        // The Strangeness after addition
             G4double dM=totMass-totM;
 #ifdef fdebug
-		          G4cout<<"G4QEnv::HadrQE: Add H="<<last4M<<lastQC<<",tM="<<tot4M<<totM<<totQC
+            G4cout<<"G4QEnv::HadrQE: Add H="<<last4M<<lastQC<<",tM="<<tot4M<<totM<<totQC
                   <<",dM="<<dM<<", tB="<<totBN<<", tS="<<totS<<G4endl;
 #endif
             if(dM>-0.001&&totPDG)
-		          {
+            {
               CleanUp();
               G4QHadron* evH = new G4QHadron(totPDG,tot4M);//Create Hadron for ResidNucleus
               EvaporateResidual(evH);           // Evaporate ResNuc (del.equiv)
               break;
-		          }
+            }
             nOfOUT  = theQHadrons.size();       // Update the value of OUTPUT entries
-		        } // End of WHILE(nOfOUT)
+          } // End of WHILE(nOfOUT)
           nOfOUT  = theQHadrons.size();         // Update the value of OUTPUT entries
-		        if(!nOfOUT)
-		        {
-		          G4cout<<"---Warning---G4QEnv::HadrQE:M="<<totMass<<"<gsM="<<totM<<",dM="<<dM
+          if(!nOfOUT)
+          {
+            G4cout<<"---Warning---G4QEnv::HadrQE:M="<<totMass<<"<gsM="<<totM<<",dM="<<dM
                   <<", tPDG="<<totPDG<<", t4M="<<tot4M<<G4endl;
-			         // throw G4QException("G4QEnvironment::HadronizeQEnv:Can't decayExhostedQEnv");
+            // throw G4QException("G4QEnvironment::HadronizeQEnv:Can't decayExhostedQEnv");
             CleanUp();
             G4QHadron* evH = new G4QHadron(totPDG,tot4M);// Create Hadron for ResidNucleus
             EvaporateResidual(evH);             // Evaporate ResidNucl (del.equiv)
-	         }
-		      }
+          }
+        }
         else                                    // "Last decay was fatal" case @@ buggy ?MK
-		      {
-#ifdef pdebug
-		        G4cout<<"***G4QEnv::HadrQE: M="<<totMass<<",dM="<<dM<<",nQ="<<nQuasmons<<G4endl;
+        {
+#ifdef pdebug
+          G4cout<<"***G4QEnv::HadrQE: M="<<totMass<<",dM="<<dM<<",nQ="<<nQuasmons<<G4endl;
 #endif
           G4Quasmon* quasH = new G4Quasmon(totQC,tot4M);
           CleanUp();
-		        if(!CheckGroundState(quasH,true))
+          if(!CheckGroundState(quasH,true))
           {
             G4QHadron* hadr = new G4QHadron(totQC,tot4M);
@@ -3841,6 +3994,6 @@
         }
         CleanUp();
-	     }
-	   } // End of "infinit" WHILE LOOP
+      }
+    } // End of "infinit" WHILE LOOP
   } // End of the "Nuclear Environment" case
   return theQHadrons;
@@ -3872,16 +4025,23 @@
   G4int thePDG = qH->GetPDGCode();           // Get PDG code of the Residual Nucleus
   G4int theBN  = qH->GetBaryonNumber();      // A (Baryon number of the nucleus)
+  G4QContent  theQC  = qH->GetQC();          // Quark Content of the hadron
+  G4int theS=theQC.GetStrangeness();         // S (Strangeness of the nucleus)
 #ifdef pdebug
   G4cout<<"G4QE::EvaporateRes:Called for PDG="<<thePDG<<",4M="<<qH->Get4Momentum()<<G4endl;
 #endif
-  if(theBN==1)
+  if(theS<0)                                 // Antistrange nucleus
+  {
+#ifdef pdebug
+    G4cout<<"G4QE::EvaporateRes: AntistrangeNucleus="<<thePDG<<qH->Get4Momentum()<<G4endl;
+#endif
+    DecayAntistrange(qH);                    // (delete equivalent)
+    return;
+  }
+  else if(theBN==1)
   {
 #ifdef pdebug
     G4cout<<"G4QE::EvaporateRes: Baryon="<<thePDG<<qH->Get4Momentum()<<G4endl;
 #endif
-    DecayBaryon(qH);                     // (delete equivalent)
-#ifdef qdebug
-    qH=0;
-#endif
+    DecayBaryon(qH);                         // (delete equivalent)
     return;
   }
@@ -3895,12 +4055,7 @@
     //DecayMeson(qH);                        // @@
     theQHadrons.push_back(qH);
-#ifdef qdebug
-    qH=0;
-#endif
     return;
   }
-  G4QContent  theQC  = qH->GetQC();          // Quark Content of the hadron
   G4int theC=theQC.GetCharge();              // P
-  G4int theS=theQC.GetStrangeness();         // S
   if(!thePDG) thePDG = theQC.GetSPDGCode();  // If there is no PDG code, get it from QC
   if(thePDG==10&&theQC.GetBaryonNumber()>0) thePDG=theQC.GetZNSPDGCode();
@@ -3925,7 +4080,4 @@
   {
     theQHadrons.push_back(qH);               // fill As It Is
-#ifdef qdebug
-     qH=0;
-#endif
   }
   else if(totMass>totGSM)
@@ -3972,5 +4124,5 @@
 } // End of EvaporateResidual
 
-//The public Hadronisation function with the Exception treatment (del respons. of User !)
+//Public Hadronisation function with Exception treatment (del is responsibility of User!)
 G4QHadronVector* G4QEnvironment::Fragment()
 {//              ==========================
@@ -4039,5 +4191,5 @@
     {
       RepFlag=false;                      // If OK - go out of the while
-      theFragments = FSInteraction();     //InterClass creation. User must delet QHadrons.
+      theFragments = FSInteraction();     // InterClass creation. User must delet QHadrons.
     }
     catch (G4QException& error)
@@ -4055,5 +4207,5 @@
         G4QHadron* cH = theQHadrons[ph];
         dif-=cH->Get4Momentum();
-		      G4cout<<"***G4QEnvir::Fr:H"<<ph<<"="<<cH->Get4Momentum()<<cH->GetPDGCode()<<G4endl;
+        G4cout<<"***G4QEnvir::Fr:H"<<ph<<"="<<cH->Get4Momentum()<<cH->GetPDGCode()<<G4endl;
       }
       for(G4int pq=0; pq<nQp; pq++)
@@ -4110,9 +4262,9 @@
     G4int nProj=theProjectiles.size();
     if(nProj) for(G4int ipr=0; ipr<nProj; ipr++)
-	   {
+    {
       G4QHadron* prH = theProjectiles[ipr];
       G4cerr<<"G4QE::F:#"<<ipr<<",PDG/4M="<<prH->GetPDGCode()<<prH->Get4Momentum()<<G4endl;
     }
-	   throw G4QException("G4QEnvironment::Fragment:This reaction caused the CHIPSException");
+    throw G4QException("G4QEnvironment::Fragment:This reaction caused the CHIPSException");
     //G4Exception("G4QEnvironment::Fragment","027",FatalException,"GeneralCHIPSException");
   }
@@ -4121,10 +4273,16 @@
   if(tmpS)
   {
-    tmpS=theFragments->size();
-    intQHadrons.resize(tmpS+intQHadrons.size()); // Resize intQHadrons
-    copy(theFragments->begin(), theFragments->end(), intQHadrons.end()-tmpS);
-    tmpS=intQHadrons.size();
-    theFragments->resize(tmpS); // Resize theFragments
-    copy(intQHadrons.begin(), intQHadrons.end(), theFragments->begin());
+    //tmpS=theFragments->size();
+    //intQHadrons.resize(tmpS+intQHadrons.size());
+    //copy(theFragments->begin(), theFragments->end(), intQHadrons.end()-tmpS);
+    //tmpS=intQHadrons.size();
+    //theFragments->resize(tmpS);  // Resize theFragments
+    //copy(intQHadrons.begin(), intQHadrons.end(), theFragments->begin());
+    // Can be like this, but by performance it is closer to FNAL (but better than it)
+    //copy(theFragments->begin(), theFragments->end(), back_inserter(intQHadrons));
+    //theFragments->resize(intQHadrons.size());  // Resize theFragments
+    //copy(intQHadrons.begin(), intQHadrons.end(), theFragments->begin());
+    // The following (istead of all above) has worse performance !
+    theFragments->insert(theFragments->begin(), intQHadrons.begin(), intQHadrons.end() );
     intQHadrons.clear();
   }
@@ -4200,5 +4358,5 @@
   for (G4int is=0; is<nQuasmons; is++) // Sum 4mom's of Quasmons for comparison
   {
-	   G4Quasmon*      pQ = theQuasmons[is];
+    G4Quasmon*      pQ = theQuasmons[is];
     G4LorentzVector Q4M= pQ->Get4Momentum();
     G4cout<<"G4QE::FSI: Quasmon ("<<is<<") is added, 4M="<<Q4M<<G4endl;
@@ -4262,5 +4420,5 @@
   for (G4int js=0; js<nQuasmons; js++)    // Subtract 4mom's of Quasmons (compare)
   {                                       //                                        
-	   G4Quasmon*      prQ = theQuasmons[js];//                                  
+    G4Quasmon*      prQ = theQuasmons[js];//                                  
     if(prQ->GetStatus())                  // Subtract only if Quasmon is alive      
     {                                     //                                        
@@ -4270,5 +4428,5 @@
       t4M          -= Q4M;                // Subtract 4-momentum of the Quasmon        
       tC           -= prQ->GetQC().GetCharge(); //                            
-	   }                                     //                                        
+    }                                     //                                        
     else G4cout<<"G4QE::FSI:Dead Quasmon("<<js<<")="<<prQ->GetStatus()<<G4endl;
   } // End of Quasmons4Momentum subtractions                                  
@@ -4284,5 +4442,5 @@
       t4M          -= hs4Mom;           //                                        
       tC           -= theQHadrons[jpo]->GetCharge(); // Subtract charge of the OutHadron
-	   }                                   // End of the "FinalHadron" IF            
+    }                                   // End of the "FinalHadron" IF            
   }                                     // End of the LOOP over output hadrons    
   G4cout<<"G4QEnv::FSI:|||||4-MomCHECK||||d4M="<<t4M<<",dCharge="<<tC<<G4endl;
@@ -4292,5 +4450,5 @@
   {
     G4cout<<"---Warning---G4QEnvironment::FSInteraction: nHadrons="<<nHadr<<G4endl;
-   	//throw G4QException("G4QEnvironment::FSInteraction: No hadrons in the output");
+    //throw G4QException("G4QEnvironment::FSInteraction: No hadrons in the output");
     return theFragments;
   }
@@ -4327,7 +4485,10 @@
       if(!CheckGroundState(quasH,true))// Try to correct with other hadrons
       {
+#ifdef pdebug
+        // M.K. Fake complain in the low energy nHe/pHe reactions, while everything is OK
         G4cout<<"---Warning---G4QEnv::FSI:Correction error LeaveAsItIs h4m="<<lh4M<<G4endl;
+#endif
         theQHadrons.push_back(curHadr);// Fill theResidualNucleus asItIs(delete equivalent)
-	       //throw G4QException("G4QEnv::FSI: STOP at Correction Error");
+        //throw G4QException("G4QEnv::FSI: STOP at Correction Error");
       }
       else
@@ -4386,5 +4547,5 @@
 #endif
     if(hBN>lHadr) // Current Hadron is the Biggest fragment -> Swap with theLast Hadron
-	   {
+    {
       G4QHadron* theLast = theCurr;          // Prototype of the pointer to the Last Hadron
       G4QHadron* curHadr = new G4QHadron(theCurr);// Remember CurrentHadron for evaporation
@@ -4406,5 +4567,5 @@
       sBN  = theCurr->GetStrangeness();
       hPDG = theCurr->GetPDGCode();
-	   }
+    }
     if(hPDG==89002000||hPDG==89001001||hPDG==89000002)// 2pt dec. of anti-strange (3pt dec)
     {
@@ -4421,9 +4582,9 @@
       G4double tM = 0.;
       if(hPDG==89002000)                     // Use the prototypes above
-	     {
+      {
         if(hMi<mKmP)
-		      {
+        {
           if(hMi>mProt+mPi+mPi0)
-		        {
+          {
             sPDG=211;
             sM  =mPi;
@@ -4432,5 +4593,5 @@
           }
           else if(hMi>mProt+mPi) // @@ Does not conserve strangeness (Week decay)
-		        {
+          {
 #ifdef pdebug
             G4cout<<"**G4QE::FSI:ANTISTRANGE*++*STRANGENESS,PDG="<<hPDG<<",M="<<hM<<G4endl;
@@ -4442,6 +4603,6 @@
         }
       }
-	     else if(hPDG==89001001)
-	     {
+      else if(hPDG==89001001)
+      {
         fQPDG= nQPDG;
         fM   = mNeut;
@@ -4455,8 +4616,8 @@
           sM   = mK0;
         }
-		      else if(hMi<mKmN)
-		      {
+        else if(hMi<mKmN)
+        {
           if(hMi>mProt+mPi0+mPi0)
-		        {
+          {
             fQPDG= pQPDG;
             fM   = mProt;
@@ -4466,5 +4627,5 @@
             tM   = mPi0;
             if(hMi>mNeut+mPi+mPi0&&G4UniformRand()>.67)
-		          {
+            {
               fQPDG= nQPDG;
               fM   = mNeut;
@@ -4473,5 +4634,5 @@
             }
             if(hMi>mProt+mPi+mPi&&G4UniformRand()>.5)
-		          {
+            {
               sPDG = 211;
               sM   = mPi;
@@ -4481,5 +4642,5 @@
           }
           else if(hMi>mProt+mPi0) // @@ Does not conserve strangeness (Week decay)
-		        {
+          {
 #ifdef pdebug
             G4cout<<"**G4QE::FSI:*ANTISTRANGE*+*STRANGENESS*PDG="<<hPDG<<",M="<<hM<<G4endl;
@@ -4493,6 +4654,6 @@
         }
       }
-	     else if(hPDG==89000002)
-	     {
+      else if(hPDG==89000002)
+      {
         fQPDG= nQPDG;
         fM   = mNeut;
@@ -4500,7 +4661,7 @@
         sM   = mK0;
         if(hMi<mK0mN)
-		      {
+        {
           if(hMi>mNeut+mPi+mPi)
-		        {
+          {
             sPDG = 211;
             sM   = mPi;
@@ -4509,5 +4670,5 @@
           }
           if(hMi>mProt+mPi+mPi0)
-		        {
+          {
             fQPDG= pQPDG;
             fM   = mProt;
@@ -4518,5 +4679,5 @@
           }
           else if(hMi>mProt+mPi) // @@ Does not conserve strangeness (Week decay)
-		        {
+          {
 #ifdef pdebug
             G4cout<<"**G4QE::FSI:**ANTISTRANGE*0*STRANGENE**PDG="<<hPDG<<",M="<<hM<<G4endl;
@@ -4529,7 +4690,7 @@
           else sPDG=0;      // @@ Still can try to decay in gamma+neutron (electromagnetic)
         }
-	     }
+      }
       if(!sPDG)
-	     {
+      {
 #ifdef pdebug
         G4cout<<"***G4QE::FSI:***ANTISTRANGE***CANN'T DECAY,PDG="<<hPDG<<",M="<<hM<<G4endl;
@@ -4543,10 +4704,10 @@
         G4double sum=fM+sM;
         if(fabs(hM-sum)<=eps)
-		      {
+        {
           f4M=h4Mom*(fM/sum);
           s4M=h4Mom*(sM/sum);
-		      }
+        }
         else if(hM<sum || !G4QHadron(h4Mom).DecayIn2(f4M,s4M))
-	       {
+        {
           G4cout<<"---Warning---G4QE::FSI: Still try(2),M="<<hM<<"->"<<fM<<"("<<fQPDG<<")+"
                 <<sM<<"("<<sPDG<<")="<<sum<<G4endl;
@@ -4588,11 +4749,11 @@
             //           7. Forbid the decay
             fOK=false;
-		        }
+          }
           else
           {
             G4cerr<<"***G4QEnv::FSI: No recovery (1) Env="<<theEnvironment<<G4endl;
-	           throw G4QException("G4QEnv::FSI:ANTISTRANGE DecayIn2 did not succeed");
+            throw G4QException("G4QEnv::FSI:ANTISTRANGE DecayIn2 did not succeed");
           }
-	       }
+        }
         if(fOK)
         {
@@ -4602,5 +4763,5 @@
           theQHadrons.push_back(sH);               // (delete equivalent)
         }
-	     }
+      }
       else
       {
@@ -4611,11 +4772,11 @@
         G4double sum=fM+sM+tM;
         if(fabs(hM-sum)<=eps)
-		      {
+        {
           f4M=h4Mom*(fM/sum);
           s4M=h4Mom*(sM/sum);
           t4M=h4Mom*(tM/sum);
-		      }
+        }
         else if(hM<sum || !G4QHadron(h4Mom).DecayIn3(f4M,s4M,t4M))
-	       {
+        {
           G4cout<<"---Warning---G4QE::FSI: Still try(3), M"<<hM<<"->"<<fM<<"("<<fQPDG<<")+"
                 <<sM<<"("<<sPDG<<")+"<<tM<<"("<<tPDG<<")="<<sum<<G4endl;
@@ -4649,11 +4810,11 @@
             delete quasH;
             fOK=false;
-		        }
+          }
           else
           {
             G4cout<<"***G4QEnv::FSI: No recovery (2) Env="<<theEnvironment<<G4endl;
-	           throw G4QException("G4QEnv::FSI:ANTISTRANGE DecayIn3 did not succeed");
+            throw G4QException("G4QEnv::FSI:ANTISTRANGE DecayIn3 did not succeed");
           }
-	       }
+        }
         if(fOK)
         {
@@ -4665,7 +4826,7 @@
           theQHadrons.push_back(tH);               // (delete equivalent)
         }
-	     }
+      }
       nHadr=theQHadrons.size();
-	   }
+    }
     else if(hPDG==89999003||hPDG==90002999||hPDG==90000003||hPDG==90003000||
             hPDG==90999002||hPDG==91001999) // "3-particles decays of dibaryons and 3N"
@@ -4682,5 +4843,5 @@
       G4double tM   = mPi;
       if(hPDG==90002999)       // p,p,pi+
-	     {
+      {
         nuQPDG = pQPDG;        // Substitute p for the first n
         nucM   = mProt;
@@ -4688,7 +4849,7 @@
         barM   = mProt;
         tPDG   = 211;          // Substitute pi+ for the first pi-
-	     }
+      }
       else if(hPDG==90003000)  // 3p
-	     {
+      {
         nuQPDG = pQPDG;        // Substitute p for the first n
         nucM   = mProt;
@@ -4697,9 +4858,9 @@
         tPDG   = 2212;         // Substitute p for pi-
         tM     = mProt;
-	     }
+      }
       else if(hPDG==90999002)  // n,Lambda,pi-/n,Sigma0,pi-/n,Sigma-,gamma(@@)
-	     {
+      {
         if(hM>mSigZ+mNeut+mPi)
-		      {
+        {
           G4double ddMass=hM-mPi;          // Free CM energy
           G4double dd2=ddMass*ddMass;      // Squared free energy
@@ -4720,5 +4881,5 @@
             barPDG = 3122;     // Substitute Lambda for the second n
             barM   = mLamb;
-		        }
+          }
         }
         else if(hM>mLamb+mNeut+mPi)
@@ -4734,12 +4895,12 @@
           tM     = 0;
         }
-	     }
+      }
       else if(hPDG==91001999)  // p,Lambda,pi+/p,Sigma0,pi+/p,Sigma+,gamma(@@)
-	     {
+      {
         nuQPDG = pQPDG;        // Substitute p for the first n
         nucM   = mProt;
         tPDG   = 211;          // Substitute pi+ for the first pi-
         if(hM>mSigZ+mProt+mPi)
-		      {
+        {
           G4double ddMass=hM-mPi;          // Free CM energy
           G4double dd2=ddMass*ddMass;      // Squared free energy
@@ -4760,5 +4921,5 @@
             barPDG = 3122;     // Substitute Lambda for the second n
             barM   = mLamb;
-		        }
+          }
         }
         if(hM>mLamb+mProt+mPi)
@@ -4774,10 +4935,10 @@
           tM     = 0;
         }
-	     }
+      }
       else if(hPDG==90000003)  // 3n
-	     {
+      {
         tPDG   = 2112;         // Substitute n for pi-
         tM     = mNeut;
-	     }
+      }
       G4bool fOK=true;
       G4LorentzVector nu4M(0.,0.,0.,nucM);
@@ -4786,11 +4947,11 @@
       G4double sum=nucM+barM+tM;
       if(fabs(hM-sum)<=eps)
-	     {
+      {
         nu4M=h4Mom*(nucM/sum);
         ba4M=h4Mom*(barM/sum);
         pi4M=h4Mom*(tM/sum);
-	     }
+      }
       if(hM<sum || !G4QHadron(h4Mom).DecayIn3(nu4M,ba4M,pi4M))
-	     {
+      {
 #ifdef pdebug
         G4int eA=theEnvironment.GetA();
@@ -4814,5 +4975,5 @@
             else theCurr->SetQC(theLast->GetQC());// CurHadrPDG instead of LastHadrPDG
 #ifdef pdebug
-			         G4cout<<"---Warning---G4QE::FSI:l#"<<nhd1<<",4M="<<l4M<<",PDG="<<lQP<<G4endl;
+            G4cout<<"---Warning---G4QE::FSI:l#"<<nhd1<<",4M="<<l4M<<",PDG="<<lQP<<G4endl;
 #endif
             theCurr->Set4Momentum(theLast->Get4Momentum()); // ... 4Momentum substitution
@@ -4838,11 +4999,11 @@
           delete quasH;
           fOK=false;
-		      //}
-		      //else
-		      //{
+        //}
+        //else
+        //{
         //  G4cerr<<"***G4QEnv::FSI:NoRec(3)E="<<theEnvironment<<eA<<",PDG="<<hPDG<<G4endl;
-	       //  throw G4QException("G4QEnv::FSI:ISO-dibaryon or 3n/3p DecayIn3 error");
-		    //}
-	     }
+        //  throw G4QException("G4QEnv::FSI:ISO-dibaryon or 3n/3p DecayIn3 error");
+      //}
+      }
       if(fOK)
       {
@@ -4855,5 +5016,5 @@
         nHadr=theQHadrons.size();
       }
-	   }
+    }
     else if(hBN>1 && !sBN && (cBN<0 || cBN>hBN)) // "nN+mD- or nP+mD++ decay"
     {
@@ -4871,5 +5032,5 @@
       G4int    nPi  = -cBN;    // a#of Pi-'s
       if( cBN>hBN)             // reinitialization for the "(n+m)*P,m*pi+" case
-	     {
+      {
         nuQPDG = pQPDG;        // Substitute p for the first n
         nucM   = mProt;
@@ -4887,11 +5048,11 @@
       G4double sum=nucM+barM+tM;
       if(fabs(hM-sum)<=eps)
-	     {
+      {
         nu4M=h4Mom*(nucM/sum);
         ba4M=h4Mom*(barM/sum);
         pi4M=h4Mom*(tM/sum);
-	     }
+      }
       if(hM<sum || !G4QHadron(h4Mom).DecayIn3(nu4M,ba4M,pi4M))
-	     {
+      {
 #ifdef pdebug
         G4cout<<"***G4QEnv::FSI:IsN M="<<hM<<","<<hPDG<<"->N="<<nuQPDG<<"(M="<<nucM<<")+"
@@ -4930,11 +5091,11 @@
           delete quasH;
           fOK=false;
-		      }
+        }
         else
         {
           G4cout<<"***G4QEnv::FSI:IN,NoRec(4) Env="<<theEnvironment<<",PDG="<<hPDG<<G4endl;
-	         throw G4QException("G4QEnv::FSI:IN Multy ISO-dibaryon DecayIn3 did not succeed");
-        }
-	     }
+          throw G4QException("G4QEnv::FSI:IN Multy ISO-dibaryon DecayIn3 did not succeed");
+        }
+      }
       if(fOK)
       {
@@ -5027,5 +5188,5 @@
         G4double     tM =mPi;
         if(hPDG==90002999)
-		      {
+        {
           fQPDG=pQPDG;
           fM   =mProt;
@@ -5040,11 +5201,11 @@
         G4double sum=fM+sM+tM;
         if(fabs(hM-sum)<=eps)
-		      {
+        {
           f4M=h4Mom*(fM/sum);
           s4M=h4Mom*(sM/sum);
           t4M=h4Mom*(tM/sum);
-		      }
+        }
         else if(hM<sum || !G4QHadron(h4Mom).DecayIn3(f4M,s4M,t4M))
-	       {
+        {
           G4cout<<"---WARNING---G4QE::FSI: Still trying, NDM="<<hM<<"->"<<fM<<"("<<fQPDG
                 <<")+"<<sM<<"("<<sPDG<<")+"<<tM<<"("<<tPDG<<")="<<sum<<G4endl;
@@ -5076,11 +5237,11 @@
             delete quasH;
             fOK=false;
-		        }
+          }
           else
           {
             G4cout<<"***G4QEnv::FSI: No ND recovery Env="<<theEnvironment<<G4endl;
-	           throw G4QException("G4QEnv::FSI:ND DecayIn3 did not succeed");
+            throw G4QException("G4QEnv::FSI:ND DecayIn3 did not succeed");
           }
-	       }
+        }
         if(fOK)
         {
@@ -5095,5 +5256,5 @@
         hQPDG= G4QPDGCode(hPDG);
         hGSM = hQPDG.GetMass();                  // Change GroundStateMass of theFirstFragm
-	     }
+      }
       nHadr=theQHadrons.size();
       if(hPDG==89001001||hPDG==89002000||hPDG==89000002)
@@ -5107,5 +5268,5 @@
         G4double     sM =mK0;
         if(hPDG==89000002)
-		      {
+        {
           fQPDG=pQPDG;
           fM   =mProt;
@@ -5114,5 +5275,5 @@
         }
         if(hPDG==89001001)
-		      {
+        {
           if(hM<mK0+mProt || G4UniformRand()>.5)
           {
@@ -5131,10 +5292,10 @@
         G4double sum=fM+sM;
         if(fabs(hM-sum)<=eps)
-		      {
+        {
           f4M=h4Mom*(fM/sum);
           s4M=h4Mom*(sM/sum);
-		      }
+        }
         else if(hM<sum || !G4QHadron(h4Mom).DecayIn2(f4M,s4M))
-	       {
+        {
           G4cout<<"---WARNING---G4QE::FSI: Still trying (2),NDM="<<hM<<"->"<<fM<<"("<<fQPDG
                 <<")+"<<sM<<"("<<sPDG<<")="<<sum<<G4endl;
@@ -5166,11 +5327,11 @@
             delete quasH;
             fOK=false;
-		        }
+          }
           else
           {
             G4cerr<<"***G4QEnv::FSI: No KN recovery Env="<<theEnvironment<<G4endl;
-	           throw G4QException("G4QEnv::FSI:KN DecayIn2 did not succeed");
+            throw G4QException("G4QEnv::FSI:KN DecayIn2 did not succeed");
           }
-	       }
+        }
         if(fOK)
         {
@@ -5183,5 +5344,5 @@
         hQPDG= G4QPDGCode(hPDG);
         hGSM = hQPDG.GetMass();                  // Change GroundStateMass of theFirstFragm
-	     }
+      }
       nHadr=theQHadrons.size();
       G4int           hS = curHadr->GetStrangeness();
@@ -5199,10 +5360,10 @@
       G4cout<<"G4QE::FSI:h="<<hPDG<<",S="<<hS<<",B="<<hB<<",#"<<hadron<<"<"<<nHadr<<G4endl;
 #endif
-	     //if(hadron&&!hF&&hB>0&&!hS&&(nHadr>3||hB<2)) // ThermoBackFus (VIMP for gamA TotCS)
-	     //if(hadron&&!hF&&hB>0&&!hS&&(nHadr>2||hB<4)) // ThermoBackFus (VIMP for gamA TotCS)
-	     if(hadron&&!hF&&hB>0&&!hS) // ThermoBackFusion cond. (VIMP for gamA TotCS)
-	     //if(hadron&&!hF&&hB>0&&hB<4&&!hS) // ThermoBackFusion cond. (VIMP for gamA TotCS)
-	     //if(hadron&&!hF&&hB>0&&!hS&&nHadr>2)//ThermoBackFusion MAX condition (VIMP for gamA)
-	     //if(2>3)                         // Close the ThermoBackFusion (VIMP for gamA TotCS)
+      //if(hadron&&!hF&&hB>0&&!hS&&(nHadr>3||hB<2)) // ThermoBackFus (VIMP for gamA TotCS)
+      //if(hadron&&!hF&&hB>0&&!hS&&(nHadr>2||hB<4)) // ThermoBackFus (VIMP for gamA TotCS)
+      if(hadron&&!hF&&hB>0&&!hS) // ThermoBackFusion cond. (VIMP for gamA TotCS)
+      //if(hadron&&!hF&&hB>0&&hB<4&&!hS) // ThermoBackFusion cond. (VIMP for gamA TotCS)
+      //if(hadron&&!hF&&hB>0&&!hS&&nHadr>2)//ThermoBackFusion MAX condition (VIMP for gamA)
+      //if(2>3)                         // Close the ThermoBackFusion (VIMP for gamA TotCS)
       {
 #ifdef pdebug
@@ -5212,5 +5373,5 @@
         G4QContent hQC = curHadr->GetQC();
         if(hadron&&!hF&&hB>0) for(unsigned pt=0; pt<hadron; pt++)
-	       {
+        {
           G4QHadron* backH = theQHadrons[pt];   // Get pointer to one of thePreviousHadrons
           G4int   bF = backH->GetNFragments();
@@ -5238,27 +5399,27 @@
 #ifdef pdebug
           //if(nHadr==3)
-		        G4cout<<"G4QE::FSI:"<<pt<<",B="<<bB<<",S="<<bS<<",p="<<pCM2<<"<"<<p2cut<<",hB="
+          G4cout<<"G4QE::FSI:"<<pt<<",B="<<bB<<",S="<<bS<<",p="<<pCM2<<"<"<<p2cut<<",hB="
                 <<hB<<",bM+hM="<<bM+hM<<">tM="<<tM<<",tQC="<<sQC<<G4endl;
 #endif
           //if(!bF&&(bB==1||hB==1)&&bM+hM>tM+.001&&pCM2<p2cut)      // Only baryons == pcut
-		        //if(!bF&&!bS&&(bB==1&&hB>0||hB==1&&bB>0)&&bM+hM>tM+.00001
+          //if(!bF&&!bS&&(bB==1&&hB>0||hB==1&&bB>0)&&bM+hM>tM+.00001
           //   && (pCM2<p2cut&&nHadr>3||pCM2<p2cut2&&nHadr==3))
-		        //if(!bF&&(bB==1||hB==1)&&bM+hM>tM+.001&&(pCM2<p2cut&&nHadr>3 ||
-		        //   pCM2<p2cut2&&nHadr==3&&bPDG>90000000))
+          //if(!bF&&(bB==1||hB==1)&&bM+hM>tM+.001&&(pCM2<p2cut&&nHadr>3 ||
+          //   pCM2<p2cut2&&nHadr==3&&bPDG>90000000))
           //if(!bF&&bB<4&&bM+hM>tM+.001&&pCM2<p2cut)
           if(!bF&&!bS&&bB>0&&bM+hM>tM+.001&&pCM2<p2cut)
           //if(!bF&&bB<4&&bM+hM>tM+.001&&(pCM2<p2cut || bB+hB==4&&pCM2<p2cut2))
-		        //if(!bF&&(bB==1||hB==1)&&(nHadr>3||bPDG>90000000)&&bM+hM>tM+.001&&pCM2<p2cut)
-		        //if(!bF&&(bB==1&&!bC||hB==1&&!hC)&&bM+hM>tM+.001&&pCM2<p2cut)// Only n == pcut
-		        //if(!bF&&(bB==1||hB==1)&&bM+hM>tM+.001&&sM-bM-hM<cut)  // Only baryons == ecut
-		        //if(!bF&&bB&&bB<fL&&bM+hM>tM+.001&&sM-bM-hM<cut)    // Light fragments == ecut
-	         {
+          //if(!bF&&(bB==1||hB==1)&&(nHadr>3||bPDG>90000000)&&bM+hM>tM+.001&&pCM2<p2cut)
+          //if(!bF&&(bB==1&&!bC||hB==1&&!hC)&&bM+hM>tM+.001&&pCM2<p2cut)// Only n == pcut
+          //if(!bF&&(bB==1||hB==1)&&bM+hM>tM+.001&&sM-bM-hM<cut)  // Only baryons == ecut
+          //if(!bF&&bB&&bB<fL&&bM+hM>tM+.001&&sM-bM-hM<cut)    // Light fragments == ecut
+          {
 #ifdef fdebug
             G4int bPDG = backH->GetPDGCode();
-			         if(sPDG==89999003||sPDG==90002999||sPDG==89999002||sPDG==90001999)
+            if(sPDG==89999003||sPDG==90002999||sPDG==89999002||sPDG==90001999)
               G4cout<<"G4QE::FSI:**nD-/pD++**,h="<<hPDG<<",hB="<<hB<<",b="<<bPDG<<",bB="
                     <<bB<<G4endl;
             //if(nHadr==3)
-	           G4cout<<"G4QE::FSI:*FUSION*#"<<hadron<<"["<<hPDG<<"]"<<hM<<"+#"<<pt<<"["<<bPDG
+            G4cout<<"G4QE::FSI:*FUSION*#"<<hadron<<"["<<hPDG<<"]"<<hM<<"+#"<<pt<<"["<<bPDG
                   <<"]"<<bM<<"="<<bM+hM<<", sM="<<sM<<">["<<sPDG<<"]"<<tM<<",p2="<<pCM2
                   <<"<"<<p2cut<<G4endl;
